> For the complete documentation index, see [llms.txt](https://docs.onum.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.onum.com/the-workspace/listeners/listener-integrations/pull-data-from-http-endpoints/collect-data-from-doppel.md).

# Collect data from Doppel

## Overview

Get a list of Doppel alerts through the [Doppel API](https://doppel.readme.io/reference/get-alerts) using the **HTTP Pull** Listener.

## HTTP Pull Listener configuration

In Falcon Onum, go to the **Listeners** area and click **New Listener > HTTP Pull**. Give a name to your new Listener and enter the following data:

### Parameters

N/A

### Secrets

You must define these credentials in Onum:

* `x-api-key` will reference your Doppel API Key.
* `x-user-api-key` will reference your Doppel User API Key.

To do it, click **Add element** and enter a **Name** for the secret (in this case, `x-api-key`). Then, click the **Value** field and select **New secret** to create a new one:

* Give the secret a **Name**.
* Turn off the **Expiration date** option.
* Click **Add new value** and paste the secret corresponding to the value.
* Click **Save**.

You can now select the secret you just created in the **Value** field list. Repeat the process for the `x-user-api_key`.

{% hint style="info" %}
Learn more about secrets in Onum in [this article](/administration/global-settings/organization-settings/secrets-management.md).
{% endhint %}

### Setup

After entering the required parameters and secrets, you can choose to manually enter the rest of configuration fields, or simply paste the given YAML:

{% tabs %}
{% tab title="Config as YAML" %}
Toggle this **ON** to enable a free text field where you can paste your **Tenable** YAML.

```yaml
withTemporalWindow: true
temporalWindow:
  duration: 5m
  offset: 5m
  tz: UTC
  format: "2006-01-02T15:04:05"
withAuthentication: false
withEnumerationPhase: false
collectionPhase:
  paginationType: "page"
  pageSize: 200
  isZeroIndex: true
  request:
    responseType: json
    method: "GET"
    url: "https://api.doppel.com/v1/alerts"
    headers:
      - name: Accept
        value: "application/json"
      - name: Content-Type
        value: "application/json"
      - name: x-api-key
        value: ${secrets.x-api-key}
      - name: x-user-api-key
        value: ${secrets.x-user-api-key}
    queryParams: 
      - name: created_after
        value: ${temporalWindow.from}
      - name: created_before
        value: ${temporalWindow.to}
      - name: page
        value: ${pagination.pageNumber}
      - name: page_size
        value: ${pagination.pageSize}
  output:
    select: ".data.alerts"
    map: "."
    outputMode: "element"
```

{% endtab %}

{% tab title="Manually configure" %}
**Temporal Window**

Toggle **ON** to add a temporal window for events. This repeatedly shifts the time window over which data is collected.

* **Duration** - `5m`
* **Offset** - `5m`
* **Format** - `RFC3339`

**Collection Phase**

* **Pagination Type**<mark style="color:red;">**\***</mark> - `PageNumber/PageSize`
* **Zero Index**<mark style="color:$primary;">**\***</mark> - `true`
* **Page Size**<mark style="color:$primary;">**\***</mark> - `200`
* **Request**
  * **Response Type**<mark style="color:$primary;">**\***</mark> - `JSON`
  * **Method**<mark style="color:$primary;">**\***</mark> - `GET`
  * **URL**<mark style="color:$primary;">**\***</mark> - `https://api.doppel.com/v1/alerts`
* **Headers**
  * **Name** - `Accept`
  * **Value** - `application/json`
  * **Name** - `Content-Type`
  * **Value** - `application/json`
  * **Name** - `x-api-key`
  * **Value** - `${secrets.x-api-key}`
  * **Name** - `x-user-api-key`
  * **Value** - `${secrets.x-users-api-key}`
* **Query Params**
  * **Name** - `created_after`
  * **Value** - `${temporalWindow.from}`
  * **Name** - `created_before`
  * **Value** - `${temporalWindow.to}`
  * **Name** - `page`
  * **Value** - `${pagination.pageNumber}`
  * **Name** - `page_size`
  * **Value** - `${pagination.pageSize}`

**Output**

* **Select**<mark style="color:$primary;">**\***</mark> - `.data.alerts`
* **Map** - `.`
* **Output Mode**<mark style="color:$primary;">**\***</mark> - `element`
  {% endtab %}
  {% endtabs %}

When you're done, click **Create labels** to move on to the next step and define the required [Labels](https://docs.onum.com/the-workspace/listeners/labels) if needed.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.onum.com/the-workspace/listeners/listener-integrations/pull-data-from-http-endpoints/collect-data-from-doppel.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
